Bug 867437 - Munin shebang error (perl -w: No such file or directory)
Munin shebang error (perl -w: No such file or directory)
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: munin (Show other bugs)
17
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-17 10:09 EDT by Andrew Okhmat
Modified: 2012-11-28 00:09 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-28 00:06:18 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Andrew Okhmat 2012-10-17 10:09:21 EDT
Description of problem:
  After last update to munin munin-2.0.7-1.fc17.noarch many plugins stop working.  Problems related to shebang string
  "#!/usr/bin/env perl -w" and munin-graph with "#!/usr/bin/env perl -T"

  
  Run plugins and I get
    /usr/bin/env: perl -w: No such file or directory
  or
    /usr/bin/env: perl -T: No such file or directory


Everything after the first word (/usr/bin/env) is passed as a single argument string. Safest/most portable is to not put anything after the perl there
Comment 1 d. johnson 2012-10-17 11:13:39 EDT
Next release will use "#!/usr/bin/perl" instead of env. 

(If you still want to use env, it would look like "#!/usr/bin/env PERL5OPT=-T perl" instead.)
Comment 2 Lonni J Friedman 2012-10-17 17:04:25 EDT
same problem here.  Is there a simple workaround that doesn't require me to fix every plugin manually or downgrade munin?
Comment 3 Michael 2012-10-17 17:36:46 EDT
Installing perl-Taint-Runtime resolved the -T issue for me.
Comment 4 Andrew Okhmat 2012-10-17 18:11:03 EDT
(In reply to comment #2)
> same problem here.  Is there a simple workaround that doesn't require me to
> fix every plugin manually or downgrade munin?

Crazy idea that will help you: create a symbolic link
  ln -s /usr/bin/perl '/usr/bin/perl -w'
  ln -s /usr/bin/perl '/usr/bin/perl -T'
Comment 5 Lonni J Friedman 2012-10-17 18:12:32 EDT
(In reply to comment #4)
> (In reply to comment #2)
> > same problem here.  Is there a simple workaround that doesn't require me to
> > fix every plugin manually or downgrade munin?
> 
> Crazy idea that will help you: create a symbolic link
>   ln -s /usr/bin/perl '/usr/bin/perl -w'
>   ln -s /usr/bin/perl '/usr/bin/perl -T'

ugh, symlinks with spaces.  does this actually work for you?
Comment 6 Andrew Okhmat 2012-10-17 18:23:20 EDT
Yes. Try small script for test:
=======envtest=========
#!/usr/bin/env perl -w
print "It works!";
=======================


CONSOLE OUTPUT:
=======================
$ chmod +x envtest
$ ./envtest
/usr/bin/env: perl -w: No such file or directory

$ sudo ln -s /usr/bin/perl '/usr/bin/perl -w'
$ ./envtest
It works!
=======================
Comment 7 Lonni J Friedman 2012-10-17 18:45:51 EDT
ok, thanks.  I guess I'll give that a try until this bug is fixed.
Comment 8 Lonni J Friedman 2012-10-18 11:27:53 EDT
While symlinking '/usr/bin/perl -w' helps, I still get errors about the 'perl -T' calls.  I tried creating a symlink for that too, but then the cronjob fails with:
"-T" is on the #! line, it must also be used on the command line at /usr/share/munin/munin-graph line 1.


So this still seems like a completely broken mess.
Comment 9 Lonni J Friedman 2012-10-18 11:39:28 EDT
From what I can tell, even with the symlink hacks, everything remains completely broken.  I've given up, and manually downgraded to the previous version (2.0.6-2), which while not perfect, was at least mostly functional.  

Anyone else that wants it, can get the RPMs from here:
http://koji.fedoraproject.org/koji/buildinfo?buildID=353206

Sadly, 'yum downgrade' only seems to go back to the original version in the repo (1.4.x), rather than the previously installed version.
Comment 10 Fedora Update System 2012-10-19 23:34:40 EDT
munin-2.0.7-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/munin-2.0.7-3.fc16
Comment 11 Fedora Update System 2012-10-19 23:35:32 EDT
munin-2.0.7-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/munin-2.0.7-3.fc17
Comment 12 Fedora Update System 2012-10-19 23:36:37 EDT
munin-2.0.7-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/munin-2.0.7-3.fc18
Comment 13 Fedora Update System 2012-10-19 23:37:36 EDT
munin-2.0.7-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/munin-2.0.7-3.el5
Comment 14 Fedora Update System 2012-10-19 23:38:56 EDT
munin-2.0.7-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/munin-2.0.7-3.el6
Comment 15 Fedora Update System 2012-10-20 15:48:38 EDT
Package munin-2.0.7-3.el5:
* should fix your issue,
* was pushed to the Fedora EPEL 5 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing munin-2.0.7-3.el5'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2012-13237/munin-2.0.7-3.el5
then log in and leave karma (feedback).
Comment 16 Fedora Update System 2012-11-04 12:20:12 EST
munin-2.0.7-5.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/munin-2.0.7-5.el6
Comment 17 Fedora Update System 2012-11-04 12:22:12 EST
munin-2.0.7-5.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/munin-2.0.7-5.el5
Comment 18 Fedora Update System 2012-11-11 15:33:37 EST
munin-2.0.8-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/munin-2.0.8-1.el6
Comment 19 Fedora Update System 2012-11-11 15:36:48 EST
munin-2.0.8-1.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/munin-2.0.8-1.el5
Comment 20 Fedora Update System 2012-11-28 00:06:19 EST
munin-2.0.8-1.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2012-11-28 00:09:43 EST
munin-2.0.8-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.